#include <windowsx.h>
#include <mmsystem.h>
#include <256color.h>
#include "mci.h"

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export DlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);

HINSTANCE    ghInstance;
static char  Buffer[1024];
HBITMAP      hBitmap;
HPALETTE     hPalette;
char	     MCIString[500];
int	     WantRetState;

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   char        ProgName[] = "MCI Strings";
   HWND        hWnd;
   MSG         msg;
   HMENU       hMenu;

   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.style         = CS_VREDRAW | CS_HREDRAW | CS_DBLCLKS;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
      wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wndclass.lpszMenuName  = "MCI";
      wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.lpszClassName = ProgName;

      RegisterClass(&wndclass);
   }


   ghInstance = hInstance;

   hWnd = CreateWindow(ProgName, ProgName,    
		       WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX,
		       CW_USEDEFAULT, CW_USEDEFAULT,
                       299, 212,          
                       NULL, NULL, hInstance, NULL);

   hBitmap = GetPic256(hWnd, "MCIBMP");
   hPalette = GetPicPal();
   WantRetState = 1;
   hMenu = LoadMenu(ghInstance, "MCI");
   InsertMenu(hMenu, IDM_EXIT, MF_BYCOMMAND | MF_ENABLED | MF_BITMAP, IDM_MCI, (LPCSTR) hBitmap);
   SetMenu(hWnd, hMenu);
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   return msg.wParam;
}

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_SETFOCUS :
      {
	RefreshPicPal(hWnd, hPalette);
      }
      case WM_PAINT :
      {
	RefreshPicture(hWnd, hBitmap, hPalette, 0, 0, 0, 0, 0, 0);
        return 0;
      }
      case WM_DESTROY :
      {
	DeletePic(hBitmap);
	DeletePal(hPalette);
	DeleteObject(hBitmap);
        DeleteObject(hPalette);
	PostQuitMessage(0);
        return 0;
      }
      case WM_LBUTTONDBLCLK :
      {
	DLGPROC AbtDlgProc;

        AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, ghInstance);
        DialogBox(ghInstance, "MCI", hWnd, AbtDlgProc);
        FreeProcInstance((FARPROC)AbtDlgProc);
        InvalidateRect(hWnd, NULL, TRUE);
	return 0;
      }
      case WM_COMMAND :
      {
	return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argused
BOOL CALLBACK _export DlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
	if (WantRetState == 0)
	{
          SendDlgItemMessage(hDlg, ID_WANTRET, BM_SETCHECK, 1, 0);
	}
	if (WantRetState == 1)
	{
          SendDlgItemMessage(hDlg, ID_WANTRET, BM_SETCHECK, 0, 0);
	}
	return TRUE;
      }

      case WM_COMMAND :
      {
	return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam, WMDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
   switch (id)
   {
      case IDM_EXIT :
      {
	DestroyWindow(hWnd);
        break;
      }
      case IDM_MCI :
      {
/*	DLGPROC AbtDlgProc;

        AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, ghInstance);
        DialogBox(ghInstance, "MCI", hWnd, AbtDlgProc);
        FreeProcInstance((FARPROC)AbtDlgProc);
	InvalidateRect(hWnd, NULL, TRUE);*/
	SendMessage(hWnd, WM_LBUTTONDBLCLK, NULL, NULL);
	break;
      }
    }
}

#pragma argsused
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
      case ID_WANTRET :
      {
	if (WantRetState == 0)
	{
          SendDlgItemMessage(hDlg, ID_WANTRET, BM_SETCHECK, 0, 0);
	  WantRetState = 1;
          break;
	}
	if (WantRetState == 1)
	{
          SendDlgItemMessage(hDlg, ID_WANTRET, BM_SETCHECK, 1, 0);
	  WantRetState = 0;
	}
	break;
      }
      case ID_END :
      {
      	EndDialog(hDlg, 0);
	break;
      }
      case ID_OK :
      {
         DWORD Returns;
	 HWND  hCtrl;
	 if (GetDlgItemText(hDlg, ID_TEXTBOX, MCIString, 500))
	 { 
	   Returns = mciSendString ((LPSTR)MCIString, Buffer, 1024, NULL);
           if (Returns)
	   {
	     if (mciGetErrorString(Returns, Buffer, 1024) == TRUE)
	     {
	       MessageBox(hDlg, Buffer, "MCI Error", MB_OK | MB_ICONEXCLAMATION);
	     }
           }
	   if (!Returns)
	   {
             hCtrl = GetDlgItem(hDlg, ID_WANTRET);
	     Returns = SendMessage(hCtrl, BM_GETCHECK, 0, 0L);
	     if (Returns)
             {
	       MessageBox(hDlg, Buffer, "MCI Message", MB_OK | MB_ICONASTERISK);
             }
           }
	 }
      }
   }
}
